#include <stdio.h>
#include <stdlib.h>

int easterday, eastermonth,
	carnivalday, carnivalmonth;
static int NbrDays[] =
{
	31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };

/* dayofweek(y,m) foi extraido do FAQ de C de Steve Summit */
int dayofweek(int y, int m)
{				/* 0 = Sunday */
	static int t[] =
	    {
		0, 3, 2, 5, 0, 3, 5, 1, 4, 6, 2, 4			};

	y -= m < 3;
	return ((y + y / 4 - y / 100 + y / 400 + t[m - 1] + 1) % 7);
}

/* isleapyear(y) foi extraido do FAQ de C de Steve Summit*/
int isleapyear(int year)
{
	return (year % 4 == 0 && (year % 100 != 0 || year % 400 == 0));
}

/*
 Pascoa: e' sempre o primeiro domingo apos a primeira lua cheia do outono no
 Hemisferio Sul ou da primavera europia.
 Carnaval: retrocede-se 46 dias em relacao 'a Pascoa - quarenta dias da
 Quaresma e mais seis da Semana Santa - e chega-se 'a Quarta-Feira de Cinzas.
 Os tres dias anteriores correspondem ao periodo de Carnaval.
 (SuperInteressante n.2 Nov/1987)
 Na funcao foi calculado 47 dias antes da Pascoa obtendo-se assim o dia de
 Carnaval.
*/
void findeastercarnival(int year/*,int *easter_month, int *easter_day*/)
{
	int a,b,c,e,g,h,i,k,u,x,z;
	div_t f;

	/*
	**  Gauss' famous algorithm (I don't know how or why it works,
	**  so there's no commenting)
	*/

	a = year % 19;
	f = div(year,100);
	b = f.quot;
	c = f.rem;
	f = div(b,4);
	z = f.quot;
	e = f.rem;
	f = div((8*b + 13),25);
	g = f.quot;
	f = div((19*a + b - z - g + 15),30);
	h = f.rem;
	f = div((a + 11*h),319);
	u = f.quot;
	f = div(c,4);
	i = f.quot;
	k = f.rem;
	f = div((2*e + 2*i - k - h + u + 32),7);
	x = f.rem;
	f = div((h-u+x+90),25);
	eastermonth= f.quot;
	f = div((h-u+x + eastermonth +19),32);
	easterday= f.rem;

	/* Calcula o dia de carnaval */
	carnivalday= NbrDays[eastermonth - 2] + easterday - 47;
	if (carnivalday<1){
		carnivalmonth= eastermonth - 2;
		carnivalday= NbrDays[carnivalmonth - 1] + carnivalday;
	}
	else
		carnivalmonth= eastermonth - 1;


	printf(" carnaval: %2d/%02d/%d  ", carnivalday, carnivalmonth,year);
	printf(" pascoa: %2d/%02d/%d\n", easterday, eastermonth,year);
}

void printholidays(int year, int month)
{
	if (month==eastermonth)
		printf(" %d: Dia de Pascoa\n", easterday);
	if (month==carnivalmonth)
		printf(" %d: Dia de Carnaval\n", carnivalday);
	switch (month){
	case 1:
		printf(" 01: Dia da Paz Mundial\n"
			    "");
		break;
	case 2:
		printf(" feriados de fevereiro\n");
		break;
	case 3:
		printf(" feriados de marco\n");
		break;
	case 4:
		printf(" feriados de abril\n");
		break;
	case 5:
		printf(" 01: Dia do Trabalho\n");
		break;
	case 6:
		printf(" feriados de junho\n");
		break;
	case 7:
		printf(" feriados de julho\n");
		break;
	case 8:
		printf(" feriados de agosto\n");
		break;
	case 9:
		printf(" feriados de setembro\n");
		break;
	case 10:
		printf(" feriados de outubro\n");
		break;
	case 11:
		printf(" feriados de novembro\n");
		break;
	case 12:
		printf(" feriados de dezembro\n");
		break;
	}

}

void printcalendar(int year, int month)
{
	int DayOfWeek, DayOfMonth, DaysOfMonth;
	static char *MonthLbl[] =
	    {
		"Janeiro", "Fevereiro", "Marco",
		"Abril", "Maio", "Junho", "Julho",
		"Agosto", "Setembro", "Outubro",
		"Novembro", "Dezembro"			};

	printf("\n %s / %d\n", MonthLbl[month - 1], year);
	printf(" dom seg ter qua qui sex sab\n");
	DaysOfMonth = NbrDays[month - 1] + (isleapyear(year) && (month == 2) ? 1 : 0);
	DayOfWeek = 0;
	DayOfMonth = 1 - dayofweek(year, month);
	for (; DayOfWeek < 7; DayOfWeek++, DayOfMonth++) {
		if (DayOfMonth <= 0)
			printf("    ");
		else
		    printf("%4d", DayOfMonth);
		if (DayOfMonth == DaysOfMonth) {
			printf("\n\n");
			return;
		}
		if (DayOfWeek == 6) {
			printf("\n");
			DayOfWeek = -1;
		}
	}
}

int main(int argc, char* argv[])
{
	if((argc < 3)||atoi(argv[1])>12)
	{
		printf("Uso: CAL mes ano\n"
			    "*ano* no formato de quatro digitos\n\n");
		exit(EXIT_FAILURE);
	}
	findeastercarnival(atoi(argv[2]));
	printcalendar(atoi(argv[2]), atoi(argv[1]));
	printholidays(atoi(argv[2]), atoi(argv[1]));
	return 0;
}
